(vl-load-com)
(defun C:SLD ()
  (td-move-dims-to-layer (getvar "CLAYER"))
  (princ)
)

(defun td-move-dims-to-layer (layer / doc td-error-handler)
  (defun td-error-handler (msg)
    (setvar "MODEMACRO" "")
    (princ msg)
    (vla-regen doc acactiveviewport)
    (td-restore-layer-status)
    (princ)
  )
  (defun td-process-block-items ()
    (if (= (vla-get-IsXref Blk) :vlax-false)
      (progn
        (setq count 0)
        (vlax-for Obj Blk
          (if (wcmatch (vla-get-ObjectName Obj) "AcDbAlignedDimension,AcDbRotatedDimension,AcDb2LineAngularDimension,AcDb3PointAngularDimension,AcDbArcDimension,AcDbDiametricDimension,AcDbOrdinateDimension,AcDbRadialDimension")
            (if (and layer (eq (type layer) 'STR))
              (vl-catch-all-apply 'vla-put-Layer (list Obj layer))
              (vl-catch-all-apply 'vla-delete (list Obj))
            )
          )
        )
      )
    )
  )
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (if (and (eq (type layer) 'STR) (not(tblobjname "LAYER" layer)))
    (vla-add (vla-get-Layers doc) layer)
  )
  (td-save-layer-status)
  (vlax-for Blk (vla-get-Blocks doc) (td-process-block-items))
  (td-restore-layer-status)
  (vla-regen doc acActiveViewport)
  (princ)
)

(defun td-restore-layer-status ()
  (foreach item *TD_LAYER_STATUS*
    (if (not (vlax-erased-p (car item)))
      (vl-catch-all-apply
        '(lambda ()
           (vla-put-lock (car item) (cdr (assoc "lock" (cdr item))))
           (vla-put-freeze (car item) (cdr (assoc "freeze" (cdr item))))
        )
      )
    )
  )
  (setq *TD_LAYER_STATUS* nil)
)

(defun td-save-layer-status ()
  (setq *TD_LAYER_STATUS* nil)
  (vlax-for item (vla-get-layers (vla-get-activedocument (vlax-get-acad-object)))
    (setq *TD_LAYER_STATUS* (cons (list item (cons "freeze" (vla-get-freeze item)) (cons "lock" (vla-get-lock item))) *TD_LAYER_STATUS*))
    (vla-put-lock item :vlax-false)
    (if (= (vla-get-freeze item) :vlax-true)
      (vl-catch-all-apply '(lambda () (vla-put-freeze item :vlax-false)))
    )
  )
)

(princ)
